import 'dart:io' show sleep;

import 'zavodnik.dart' show Zavodnik;
import 'generator.dart' show Generator;
import 'vyhodnotenie.dart' show Vyhodnotenie;

/// Trieda reprezentuje priebeh hry
class Hra {
  // list vygenerovaných závodníkov
  List<Zavodnik> _zavodnik_list = [];
  // počet závodníkov
  int _pocet_zavodnikov;
  // počet kôl
  int _pocet_kol;
  // meno a priezvisko zavodníka
  String _meno;
  // presnosť v strelbe, čím vyššie číslo, tým vyššia presnosť
  double _presnost;
  // pomocný list na vygenerovanie rozdielnych mien
  List<String> _meno_test = [];

  // konštruktor
  Hra () {
    // pre cyklus
    bool opakuj = true;
    // inštancia generátora
    Generator gz = new Generator();
    while (opakuj) {
      _pocet_zavodnikov = gz.generuj_hod_kockou() * 2;
      if (_pocet_zavodnikov > 4);
      opakuj = false;
    }
    // vygenerovanie rozdielnych mien
    for (var i = 0; i < _pocet_zavodnikov; i++) {
      _meno = gz.generuj_meno();
      while (_meno_test.contains(_meno))
        _meno = gz.generuj_meno();
      _meno_test.add(_meno);
    }
    // vytvorenie vygenerovaných závodníkov
    for (var i = 0; i < _pocet_zavodnikov; i++) {
      Zavodnik zavodnik;
      _presnost = gz.generuj_presnost();
      zavodnik = new Zavodnik(_meno_test[i], _presnost);
      _zavodnik_list.add(zavodnik);
    }
  }
  // spustenie hry
  start() {
    // pre cyklus
    bool opakuj = true;
    // inštancia generátora
    Generator gz = new Generator();
    // inštancia vyhodnotenia
    Vyhodnotenie vyhodn = new Vyhodnotenie(_pocet_zavodnikov);
    // nastavenie prvotnej zložitosti
    double zlozitost_terenu = 0.14;
    // generuje počet kôl po 20 km v rôznej zložitosti
    while (opakuj) {
      _pocet_kol = gz.generuj_hod_kockou();
      if (_pocet_kol > 1)
        opakuj = false;
    }
    for (var kolo = 0; kolo < _pocet_kol; kolo++) {
      print('Z A C I N A  ${kolo + 1}.  P R E T E K\n');
      // pauza na 1 sekundu, potrebný import 'dart:io' show sleep;
      sleep(const Duration(seconds: 1));
      // list s menami závodníkov (5) -> použije sa pri vyhodnocovaní
      List<String> meno_pom = [];
      // List s výsledkami kola v sekundach -> použije sa pri vyhodnocovaní
      List<double> sek_pom = [];
      // závod po jednotlivých závodníkoch
      for (var i = 0; i < _pocet_zavodnikov; i++) {
        // aby sa vedelo, či bude strelba v leže alebo v stoji
        int pocitadlo = 1;
        // vynulovanie celkového času pri novom kole
        _zavodnik_list[i].celkovy_cas_behu = 0.0;
        // vynulovanie trestných minút pri novom kole
        _zavodnik_list[i].trestne_minuty_spolu = 0;
        // beh po jednotlivých km
        for (var j = 1; j <= 20; j++) {
          _zavodnik_list[i].beh(zlozitost_terenu, j);
          // výpis po jednom km
          //print(_zavodnik_list[i].vrat_poslednu_spravu());
          // po 3., 6., 9. a 12 km je strelba
          if (j % 3 == 0 && j < 13) {
            _zavodnik_list[i].vystrel(pocitadlo, 0);
            // výpis po strelbe piatich rán
            //print(_zavodnik_list[i].vrat_poslednu_spravu());
            pocitadlo++;
          }
        }
        // uloženie výsledkov do pomocných listov
        meno_pom.add(_zavodnik_list[i].toString());
        sek_pom.add(_zavodnik_list[i].ciel_vysledok());
      }
      // vyhodnotí výsledky závodníkov v sekundách
      vyhodn.vyhodnot_sekundy(meno_pom, sek_pom, _pocet_zavodnikov);
      // zvýšenie zložitosti do ďalšieho kola
      zlozitost_terenu += 0.02;
      // pauza na 3 sekúnd
      sleep(const Duration(seconds: 3));
    }
    // vypíše konečné výsledky závodu
    vyhodn.vyhodnot_body(_pocet_zavodnikov, _zavodnik_list, _pocet_kol);
    // pauza na 20 sekúnd aby sa hneď nezavrela konzola
    sleep(const Duration(seconds: 20));
  }
}




