import 'dart:collection';

import 'zavodnik.dart';

// Trieda reprezentuje vyhodnotenie závodu
class Vyhodnotenie {
  // počet závodníkov
  int _pocet_zavodnikov;
  // list vygenerovaných závodníkov
  List<Zavodnik> _zavodnik_list = [];
  // mapa na priebežné výsledky v sekundách
  Map<String, double> _sek, _s_map;
  // mapa na priebežné výsledky v bodoch
  Map<String, int> _body, _b_map, _k_map;
  // počet bodov za umiestnenie
  final List<int> _poradie_body = [60, 54, 48, 43, 40, 38, 36, 34, 32, 31, 30, 29];
  // list na ukladanie bodov po jednotlivých závodoch
  List<int> _pom_body = [];
  List<String> _pom_mena = [];

  // prázdny konštruktor
  Vyhodnotenie(this._pocet_zavodnikov) {
    // deklarácia máp na vyhodnocovanie
    _sek = const <String, double>{};
    _s_map = new Map<String, double>.from(_sek);
    _body = const <String, int>{};
    _b_map = new Map<String, int>.from(_body);
    _k_map = new Map<String, int>.from(_body);

    // vynulovanie listu na ukladanie bodového hodnotenia
    for (var i = 0; i < _pocet_zavodnikov; i++) {
      _pom_body.add(0);
    }
  }
  // zoradenie mapy podľa hodnoty double (sekundy)
  Map<String, double> zorad_podla_hodnoty_double(Map<String, double> sekundy) {
    var zoradit_keys = sekundy.keys.toList(growable: false)
      ..sort((k1, k2) => sekundy[k1].compareTo(sekundy[k2]));
    LinkedHashMap zoradena_mapa = new LinkedHashMap
        .fromIterable(zoradit_keys, key: (k) => k, value: (k) => sekundy[k]);
    return zoradena_mapa;
  }

  // zoradenie mapy podľa hodnoty int (body)
  Map<String, int> zorad_podla_hodnoty_int(Map<String, int> body) {
    var zoradit_keys = body.keys.toList(growable: false)
      ..sort((k1, k2) => body[k1].compareTo(body[k2]));
    LinkedHashMap zoradena_mapa = new LinkedHashMap
        .fromIterable(zoradit_keys, key: (k) => k, value: (k) => body[k]);
    return zoradena_mapa;
  }
  //
  void vyhodnot_sekundy(List<String> s_list , List<double> d_list, int pocet_zavodnikov) {
    // vloženie výsledkov kola do mapy <meno, sekundy>
    for (var i = 0; i < pocet_zavodnikov; i++) {
      _s_map.addAll({s_list[i].toString(): d_list[i]});
    }
    // výpis výsledkov kola do mapy <meno, sekundy>
    _s_map.forEach((m, s) => print('$m -> ${s.toStringAsFixed(1)} sekund'));
    // zoradí mapu podľa hodnoty (value)
    _s_map = zorad_podla_hodnoty_double(_s_map);
    // uloží do mapy bodov body závodnikom podľa získaného poradia
    int i = 0;
    for (var s in _s_map.keys) {
      _b_map.addAll({s : _poradie_body[i++]});
    }
    // pripočíta body závodníkom do pomocného listu po ukončení 20 km preteku
    i = 0;
    for (var b in _b_map.values) {
      _pom_body[i++] += b;
    }
    print('');
    // vypíše body jednotlivých závodníkov po ukončení 20 km preteku
    _b_map.forEach((s, v) => print('$s -> $v bodov'));
    print('');
  }
  // vyhodnotí celkové bodové hodnotenie závodníkov a vypíše ho podľa umiestnenia
  void vyhodnot_body(int _pocet_zavodnikov, List<Zavodnik> _zavodnik_list, int _pocet_kol) {
    print('\nKonecne vysledky $_pocet_kol pretekov po 20 km:\n');
    // vloží do mapy konečné bodové hodnoty
    int i = 0;
    for (var b in _b_map.keys) {
      _b_map.addAll({b : _pom_body[i++]});
    }
    // vyčistí list
    _pom_body.clear();
    // zoradí mapu dodľa veľkosti bodov vzostupne
    _b_map = zorad_podla_hodnoty_int(_b_map);
    // uloží poradie závodníkov do pomocného listu (v opačnom poradí)
    for (var s in _b_map.keys) {
      _pom_mena.add(s);
    }
    // uloží body závodníkov do pomocného listu (v opačnom poradí)
    for (var b in _b_map.values) {
      _pom_body.add(b);
    }
    // vypíše závodníkov s bodmi v správnom poradí
    i = 1;
    for (var j = _pocet_zavodnikov - 1; j >= 0; j--) {
      print('${i++}. miesto - ${_pom_mena[j]} s ${_pom_body[j]} bodmi');
    }
    print('');
    int posledny = _pom_body.length - 1;
    if (_pom_body[posledny] == _pom_body[posledny - 1]) {
      // nastavenie cyklu
      bool novy_rozstrel = true;
      // pomocné premenné na uloženie úspechu streľby
      int a, b;
      while (novy_rozstrel) {
        // nájde potrebných závodníkov
        for (var i = 0; i < _pocet_zavodnikov; i++) {
          if (_pom_mena[posledny] == _zavodnik_list[i].toString()) {
            // do premennej uloží výsledok strelby
            a = _zavodnik_list[i].vystrel(2, 1);
            // výpis po strelbe piatich rán
            print(_zavodnik_list[i].vrat_poslednu_spravu());
          }
          if (_pom_mena[posledny - 1] == _zavodnik_list[i].toString()) {
            // do premennej uloží výsledok strelby
            b = _zavodnik_list[i].vystrel(2, 1);
            // výpis po strelbe piatich rán
            print(_zavodnik_list[i].vrat_poslednu_spravu());
          }
        }
        // podmienka či bude nový cyklus
        if (a != b) {
          // porovnanie výsledkov strelby a výpis víťaza
          if (a < b) {
            print('\nPrve miesto obsadil ${_pom_mena[posledny]}');
          }
          else {
            print('\nPrve miesto obsadil ${_pom_mena[posledny - 1]}');
          }
          // ukončenie cyklu
          novy_rozstrel = false;
        }
      }
    }
  }
}
